package com.offcn.api.study.studyl;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import sun.security.krb5.internal.Ticket;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.STUDY;
import com.offcn.system.MyRequest;
import com.offcn.system.system;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 获取直播课件日历
 * 
 * @author wff
 *
 */
public class daylesson extends STUDY implements API {
	
	public String parameter;//参数集合
	
	public String datatime_d;//
	public String  ticket;
	public String  datatime;
//	public String phone;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
		
			
	}
	
	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		ticket = MapUtil.getParameter(parameter, "offcn-ticket").trim();
		datatime = MapUtil.getParameter(parameter, "offcn-dateTime").trim();
		if ((!datatime.equals("")) && datatime.equals("code")) {
			datatime_d = DateFormat.getDateTimeInstance(2, 2, Locale.CHINESE).format(new java.util.Date());
			parameter = parameter.replace("\"offcn-dateTime\":code", "\"offcn-dateTime\":"+ "\"" + datatime_d +"\"" );
		}
		if ((!ticket.equals("")) && ticket.equals("code")) {
			ticket = Ticket;
			parameter = parameter.replace("\"offcn-ticket\":code", "\"offcn-ticket\":"+ "\"" + ticket +"\"" );
		}
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		parameter = MapUtil.getValue("parameter", data);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setParameter(parameter);
		myRequest.setUrl(Url);
		myRequest.setRequest(Request);
		//myRequest.setCookies(cookies);
		
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";
		
		String json = re.asString();
		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			
			
			if("0".equals(code)){
				
				//创建后数据库在哪个表
				//是否验证数据库
				if (!isProduct) {
//					Token =  jp.getString("data.user_info.token");
//					System.out.println( "Token=========" + Token);
//					
////					System.out.println("datavalue=======" + jp.getString("data.moment[0].tag_name"));
//					try {
//						stmt=StatementsMap.get("nwn"); //切库
//						String sql="SELECT  username  FROM `n_admin`  WHERE  id =  " + 118;
//						ResultSet rs_bankcard = this.sqlFromDB(sql);
//						stmt=StatementsMap.get("zxkt"); //切回默认
//						
//						rs_bankcard.last();
//					
//						System.out.println(rs_bankcard.getString("username"));
//						if(rs_bankcard.getString("username").contains("马增礼"))
//						{
//							System.out.println("db select successful ");
//							
//						}else {
//							result = result && false;
//							failReason = failReason + "deleted_packate  is wrong;";
//						}
//						
//						
//					} catch (Exception e) {
//						result = result && false;
//						failReason = failReason + "cannot verify template_id info in DB;";
//						e.printStackTrace();
//					}
				}
			
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}
	
	
	public static void main(String[] args) {
		
		System.out.println(DateFormat.getDateTimeInstance(2, 2, Locale.CHINESE).format(new java.util.Date()));
	}

}
